/* Copy this code in Arduino and run as it is. It reads temperature of the source where it is pointed. 
   In case of queries - reach out to us at info@bmek.in 
   www.bmek.in
 */

#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Wire.h>
#include <Adafruit_MLX90614.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels
#define OLED_RESET    -1 // Reset pin # (or -1 if sharing Arduino reset pin)

Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET); //Declaring the display name (display)
Adafruit_MLX90614 mlx = Adafruit_MLX90614();

void setup() {  
  mlx.begin(); 
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); //Start the OLED display
  display.clearDisplay();
  display.display();

}

void loop() {
  
  int i;
  float temp = 0;
  float temp1 = 0;
  float temp2 = 0;
  display.clearDisplay();
  
  display.setTextSize(1);                    
  display.setTextColor(WHITE);             
  //display.setCursor(0,4);                
  
  //display.setTextSize(1.5);
  //display.setCursor(25,1);
  //display.println("BMek Tech LLP");
  
  for (i=0;i<1000;i++)
  {
 // temp = (mlx.readObjectTempC() + temp1); // For Degree Celsius
    temp = (mlx.readObjectTempF() + temp1);   // For Degree Farhenheit 
    temp1 = temp;
    temp2 = temp/i;
  }
  
  display.setTextSize(2);
  display.setCursor(20,15);                 //Position of the data on display can be changed from here
  display.println((temp2 + 3),1);           //To caliberate - adjust the number '3' with trial and error comparing with other thermometer in case of offset readings
  
  display.setTextSize(0.5);
  display.setCursor(90,15);
  display.println("O");
  
  display.setTextSize(2);
  display.setCursor(105,15);
  display.println("F");
  
  display.display();
  
  delay(1000);

}
